--by Motig
math.randomseed(os.time())
require 'middleclass/middleclass' -- Credits to kikito
require 'Parent' --a Parent gives birth to little children/snakes!
require 'Snake' --a snake

function love.load()
	love.graphics.setCaption('Computer Snake!')
	snakeAmount = 1
	state = 0
	options = {1, 1, 8, 'normal', 0}
	selectedOption = 1
end

function love.draw()
	if state == 1 then
		love.graphics.print('FPS: '..love.timer.getFPS(), 1, 5)
		love.graphics.print('Speed: '..parent:getSpeed(), 1, 15)
		parent:draw()
	elseif state == 0 then
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.print('Press up/down to change options and left/right to increase/decrease values.', 10, 10)
		love.graphics.print('Press enter to start, press enter while running to reset. Press space to pause', 10, 20)
		love.graphics.print('You can place obstacles with the left mouse button and remove them with the right mouse button.', 10, 30)
		love.graphics.print('Placing food manually is done with the middle mouse button.', 10, 40)
		love.graphics.print('You can make the snakes go faster with mouse wheel up and slower with mouse wheel down.', 10, 50)
		if selectedOption == 1 then love.graphics.setColor(0, 255, 0, 255) else love.graphics.setColor(255, 255, 255, 255)end
		love.graphics.print('Amount of snakes: '..options[1], 10, 70)
		if selectedOption == 2 then love.graphics.setColor(0, 255, 0, 255)	else love.graphics.setColor(255, 255, 255, 255) end		
		love.graphics.print('Amount of bodies to grow when eating food: '..options[2], 10, 80)
		if selectedOption == 3 then love.graphics.setColor(0, 255, 0, 255)	else love.graphics.setColor(255, 255, 255, 255) end		
		love.graphics.print('Scale: '..options[3], 10, 90)
		if selectedOption == 4 then love.graphics.setColor(0, 255, 0, 255)	else love.graphics.setColor(255, 255, 255, 255) end		
		love.graphics.print('Drawmode: '..options[4]..' (Normal is regular Snake style and permanent makes the Snakes draw lines as they move)', 10, 100)
		if selectedOption == 5 then love.graphics.setColor(0, 255, 0, 255)	else love.graphics.setColor(255, 255, 255, 255) end	
		love.graphics.print('Delete dead snakes (1 is yes, 0 is no): '..options[5], 10, 110)
	end
end

function love.update(dt)
	if state == 1 then
		parent:updateChildren(dt)
		
		if love.mouse.isDown('l') then
			parent:placeObstacle(love.mouse.getX(), love.mouse.getY())
		elseif love.mouse.isDown('r') then
			parent:removeObstacle(love.mouse.getX(), love.mouse.getY())
		end
	end
end

function love.mousepressed(x, y, button)
	if state == 1 then
		if button == "wu" then
			parent:increaseSpeed(0.001)
		elseif button == "wd" then
			parent:decreaseSpeed(0.001)
		elseif button == 'm' then
			parent:placeFood(x, y)
		end
	end
end

function love.keypressed(button)
	if state == 0 then
		if button == 'up' then
			if selectedOption > 1 then selectedOption = selectedOption - 1 end
		elseif button == 'down' then
			if selectedOption < #options then selectedOption = selectedOption + 1 end
		elseif button == 'left' then
			if selectedOption ~= 4 then
				options[selectedOption] = options[selectedOption] - 1
			else
				if options[selectedOption] == 'normal' then options[selectedOption] = 'line' else options[selectedOption] = 'normal' end
			end
		elseif button == 'right' then
			if selectedOption ~= 4 then
				options[selectedOption] = options[selectedOption] + 1
			else
				if options[selectedOption] == 'line' then options[selectedOption] = 'normal' else options[selectedOption] = 'line' end
			end
		elseif button == 'return' then
			--Create a Parent! 
			parent = Parent:new(0.035, options[3], options[2], options[4], options[5]) -- Speed, scale, growRate, drawmode
			
			--The parent will now give birth to children.. or well Snakes in this case.
			for i = 1, options[1] do
				parent:newChild()
			end
			state = 1
		end
	elseif state == 1 then
		if button == 'return' then
			state = 0
			parent = nil
		elseif button == ' ' then
			parent:pause()
		end
	end
end